#include <string.h>
#include "sorter.h"

#define MIN(a, b) ( ((a) < (b)) ? (a) : (b) )

static int lt(char *a, char *b)
{
    int len_a = strlen(a);
    int len_b = strlen(b);

    for (int i = 0; i < MIN(len_a, len_b); i++) {
        if (a[i] < b[i])
            return 1;
        else if (a[i] > b[i])
            return -1;
    }

    return (len_a > len_b);
}

static void swap(char **arr, int x, int y)
{
    char *tmp = arr[x];
    arr[x] = arr[y];
    arr[y] = tmp;
}

void sorter_insertion_sort(char **arr, int len)
{
    for (int i = 0; i < len-1; i++) {
        char *min = arr[i];
        int min_index = i;

        for (int j = i+1; j < len; j++) {
            if (lt(arr[j], min) == 1) {
                min_index = j;
                min = arr[j];
            }
        }

        if (min_index != i)
            swap(arr, i, min_index);
    }
}
